export function parse(searchParams, replacer) {
    const params = new URLSearchParams([...new URLSearchParams(searchParams)].map(([k, v]) => [
        k.replace(/([[\]])/g, (_, s) => s === '[' ? '.' : ''),
        v,
    ]));
    const t = {};
    new Set(params.keys()).forEach((paramKey) => {
        const rawValue = params
            .getAll(paramKey)
            .join(',')
            .split(',')
            .map(n => decodeURIComponent(n.replace(/\+/g, ' ')));
        const value = rawValue.length === 1 ? rawValue[0] : rawValue;
        let key = paramKey;
        let v = replacer ?
            replacer({
                firstRawValue: params.get(paramKey).split(','),
                key,
                rawValue,
                value,
            }) :
            value;
        if (key.includes('.')) {
            const [f, ...kl] = key.split('.');
            const o = (t[f] || {});
            const l = kl.pop();
            (kl.reduce((p, n) => (p[n] ??= {}), o))[l] = v;
            key = f;
            v = o;
        }
        t[key] = v;
    });
    return t;
}
//# sourceMappingURL=parse.js.map